% The importance sampling step: consists of 3 parts:
% generate the translate (and affine if tdim=6) particles and move lset
% generate local deformation velocity particles and move lset
% perform impsampiters steps of GD towards minimizing E_{chan_vese}

% state = before GD iterations. stateIS = after GD iterations.
% state = structure containing
%C (contour), Cvel_basis (K velocity coefficients a K basis directions),
%Ctrans (translation and affine velocity), knotloc_moved (used only for parametric basis, ignore for geomtric)

% levset = structure containing lset (level set function), xco,yco (narrow band coordinates), status_set (for narrow band motion).
% level set motion still mostly uses Yogesh Rathi's code, with few changes/re-organizations.

% get_basis_fns_theta: WORST PIECE OF CODE, PROBABLY SLOWEST, can be made much better as explained in README
% HAVE NOT DONE PROFILING

function [levset,state,levsetIS,stateIS] =  mcsystemsample2(levset,state,t,Yt)
global n M order
global K K0
global alpha
global Sigma0 A a atrans Signoise signoise deform translate signoise_trans Sigma0_trans Signoise_trans deform tdim
global u0 v0 sig2obs
global sz

global zerolength changetopo atbndry setzero
global impsampling impsampiters
global dmin2 dmax2 dopt knotschange toofewknots
global nomarkov
global bias biasvec deformindx bias0  objecttype objectclass
global dispsamps
global changetopom atbndrym zerolengthm deformindxmt useKtsim
global thetaknots
global subsamplerate edgemin edgemax dmax %rho alpha sig2obsedge

if (nomarkov)
    at = 0;    atranst = 0;
else
    at = a;    atranst = atrans;
end

for m = 1:M
    for i = 1:n
        [lset,xco,yco,status_set] = getlevset(levset(i,m));
        [C,knotloc_moved, Cvel_basis] = getstate(state(i,m));
        Signoise = diag(signoise) * eye(K);  %signoise can be specified as a vector
        if (tdim==2)
            Signoise_trans = diag(signoise_trans(5:6));
        else
            Signoise_trans = diag(signoise_trans);
        end
        A = at * eye(K);
        Atrans = atranst * eye(tdim);

        if (translate)
            [C,knotloc_moved,Cvel_basis,Ctrans] = getstate(state(i,m));
            Ctrans = Atrans * Ctrans + diag(sqrt(Signoise_trans)).*randn(tdim,1);
            if (tdim==2)
                vec = [ 0 0 0 0 Ctrans(1) Ctrans(2)];        % disp('large Ctrans causes large lset motion - resulting in changetopo')
            else
                vec0 = Ctrans';
                vec = vec0;
                %   vec(2:3) = 0, vec(4) = vec0(1)  %vec(2:4) = 0; %only x and y scaling non-zero
            end
            % moves or affine deforms the lset
            centroid = mean(C,2);
            %vec = [ .1 0 0 .2 1 1]; % for testing code
            [lset,xco,yco,status_set,C,origin,zeroset] = affinetfm_geom(levset(i,m),vec,centroid);
            %             pmat = [vec(1), vec(2); vec(3), vec(4)];
            %             trans = [vec(5);vec(6)];
            %             len = length(C);
            %             [N,TT,sgn] = get_normal(C,lset);
            %             %plotcontour(C(:,1:5),'m-^');  plotcontour(C(:,5:10),'g-<'), drawnow
            %             if  (sgn==-1)      %(sgn==1)&(t>2): screwing up'
            %                 C = C(:,end:-1:1);
            %                 [N,TT,sgn] = get_normal(C,lset);
            %                 % disp(sprintf('sign %d',sgn))
            %             end
            %             cent = mean(C,2)*ones(1,len);
            %             Cvel = sum( N.*( pmat * (C-cent) + trans * ones(1,len) ) , 1);
            %             Cvel_NB=extend2(C,Cvel,lset,xco,yco);    % extend to other level sets
            %             [lset,dt_Cvel] = move_NB(Cvel_NB,lset,xco,yco,status_set,alpha,0);  % move lset
            %             getcontour_geom   % get the zero level set (contour) using the contour function
            %             [xco,yco,zeroset,xc,yc,lset,status_set,nbset] = Find_Narrow_band(lset,status_set,xco,yco,1,6*nz);
            getcontour_geom
        else
            Ctrans = zeros(tdim,1);
        end

        % the next 20 lines are only for simulation sequence, where adding bias to one knot's velocity.
        % ignore or comment out for real sequences.
        biasvec = zeros(K,1); biasvec(deformindx)=1;     %deformindx = find(sum(knotloc_moved > (sz'/2 - 10)*ones(1,K))==2);% find knots lying in fourth quadrant of image
        % correct this: works only if K, K0 close to each other: need to add/remove one point at a time as in ICASSP2
        if (K~=K0)&(~useKtsim)
            d2= mod(deformindx * K/K0 - 0.01, K);
            deformindx2 = [floor(d2)+(~floor(d2))*K, ceil(d2)]; %if floor(d2)==0: set it to 8
            biasvec = zeros(K,1); biasvec(deformindx2)=1;
        else
            d2 = deformindx;
        end
        if (n>1)  %tracking the sequence
            Signoise = Signoise + diag(biasvec)*(bias0^2); %* (2^2) ;
            %Signoise = Signoise + eye(K)*bias0^2 *2^2: DOESN'T WORK SOMETIMES
        end
        if (n==1) %simulating the sequence
            Cvel_basis = A* Cvel_basis + diag(sqrt(Signoise)).* randn(K,1) + bias*biasvec;  %Markov velocities
        else
            Cvel_basis = A* Cvel_basis + diag(sqrt(Signoise)).* randn(K,1) ;
        end


        % Locally deforming the contour: interpolate the generated velocity samples (Cvel_basis), move lset, get contour
        %Need a set of iterations bcoz need to satisfy CFL condition when moving level set
        if (deform)
            maxvel = max(abs(Cvel_basis(:)));
            totiter = max( 1 , ceil(maxvel/(2-alpha)) );
            Cdot_basis = Cvel_basis/totiter;
            for iter = 1:totiter
                %detectchangetopo,
                detectbndry   % detect if lset is near boundary
%                 Cc = C - mean(C,2)*ones(1,length(C));
%                 ang = atan2(Cc(2,:),Cc(1,:)) ;
%                 thetaCc = ang + (ang<0)*2*pi;
%                 [B] = get_basis_fns_theta(thetaCc,thetaknots,K);
%                 Cdot_basis_full(1:K,1) = Cdot_basis;
%                 Cdot_basis_full(K+1:K+order-1,1) = Cdot_basis(1:order-1);
%                 Cvel = B*Cdot_basis_full;      % interpolated velocity at C
%                 Cvel_NB=extend2(C,Cvel,lset,xco,yco);    % extend to other level sets
                centy = mean(yco); centx = mean(xco); 
                ang = atan2(yco-centy,xco-centx) ;
                thetaCc = ang + (ang<0)*2*pi;
                [B] = get_basis_fns_theta(thetaCc(:)',thetaknots,K);
                Cdot_basis_full(1:K,1) = Cdot_basis;
                Cdot_basis_full(K+1:K+order-1,1) = Cdot_basis(1:order-1);
                CvelNBvec = B*Cdot_basis_full;      % interpolated velocity at C
                Cvel_NB = zeros(size(lset));
                for ct = 1:length(xco)
                    Cvel_NB(xco(ct),yco(ct)) = CvelNBvec(ct);
                end
                [lset,dt_Cvel] = move_NB(Cvel_NB,lset,xco,yco,status_set,alpha,0);  % move lset
                getcontour_geom   % get the zero level set (contour) using the contour function
                [xco,yco,zeroset,xc,yc,lset,status_set,nbset] = Find_Narrow_band(lset,status_set,xco,yco,1,6*nz); %Later set expand = 0 (last input variable above)               
                %                  thetaknots_full = [thetaknots(:)', 2*pi+thetaknots(1:order-1)];
                %                  Cvel = interp1(thetaknots_full,Cdot_basis_full,thetaCc,'cubic');
            end   %for iter
        end % if (deform)
        state(i,m) = struct('C',C, 'Cvel_basis',Cvel_basis, 'Ctrans', Ctrans,'knotloc_moved',knotloc_moved);
        levset(i,m) = struct('lset',lset, 'xco',xco, 'yco',yco, 'status_set',status_set);

        % GD iterations
        %disp(Cvel_basis')
        
        %imshow(Yt{t},[]),    plotcontour(C,'b')
        objecttype = objectclass(m);
        if impsampling        %impsampiters = 0;   u(1:n)=u0; v(1:n)=v0;
            for iter = 1:impsampiters
                img = Yt{t};
                [bw,thresh]=edge(img,'canny',[edgemin*sqrt(sig2obs)/255  edgemax*sqrt(sig2obs)/255]);
                %imshow(bw,[]); hold on, plotcontour(C,'g') ,
                %  figure(2), imshow(img,[]), hold on
                detectbndry  %detectchangetopo,
                if (mod(iter,2)==0) % %do half as many edge iters % (t>5)&
                 %if (mod(iter,2)==2) %do NO edge iters    
                    C_subsampled = C(:,1:subsamplerate:end);
                    [edgedist,Cobs_subsampled] = findedge(C_subsampled,bw);
                    if (sum(edgedist > dmax) == 0)
                        [Nsub,TT,sgn] = get_normal(C_subsampled);
                        if (sgn==-1), Nsub = -Nsub;  end %disp('sgn negative'),
                        CvelN_subsampled = sum(Nsub.*(Cobs_subsampled - C_subsampled),1);
                        CvelN = interp1([1:subsamplerate:length(C)],CvelN_subsampled,[1:length(C)],'*cubic');
                        Cvel_NB=extend2(C,CvelN,lset,xco,yco);
                        [lset,dt_Cvel] = move_NB(Cvel_NB,lset,xco,yco,status_set,alpha,1);  % move lset
                        getcontour_geom
                        % figure(1), plotcontour(C,'m'),  drawnow
                        [xco,yco,zeroset,xc,yc,lset,status_set,nbset] = Find_Narrow_band(lset,status_set,xco,yco,1,6*nz); %Later set expand = 0 (last input variable above)
                    else, 
                    %    disp('large dist, breaking impsampiters'), 
                        break, 
                    end
                end
                [region_term,u,v] = get_velocity_chanvese(img,lset,xco,yco);
                [extend_this,sdist] = extend_initialize(lset,xco,yco,region_term);
                [sdist,extensionvel_region] = FastMarching(sdist,extend_this,6*nz);
                alpha0=alpha; alpha = 0.2;     %weight for smoothing contour
                %                 [edge_term] = get_velocity_edge(img,lset,xco,yco);
                %                 [extend_this,sdist] = extend_initialize(lset,xco,yco,edge_term);
                %                 [sdist,extensionvel_edge] = FastMarching(sdist,extend_this,6*nz);
                %                 [lset,dt_Cvel] = move_NB(extensionvel_region,lset,xco,yco,status_set,alpha,1,extensionvel_edge);
                [lset,dt_Cvel] = move_NB(extensionvel_region,lset,xco,yco,status_set,alpha,1);
                alpha = alpha0;
                getcontour_geom
                % plotcontour(C,'m')
                [xco,yco,zeroset,xc,yc,lset,status_set,nbset] = Find_Narrow_band(lset,status_set,xco,yco,1,6*nz); %Later set expand = 0 (last input variable above)
            end
            %plotcontour(C,'m'),drawnow
            stateIS(i,m) = struct('C',C, 'Cvel_basis',Cvel_basis, 'Ctrans', Ctrans,'knotloc_moved',knotloc_moved);
            levsetIS(i,m) = struct('lset',lset, 'xco',xco, 'yco',yco, 'status_set',status_set);
        end  % if impsampling
        %        deformindxmt(i,m,t) = d2;
    end %for i=1:n
    %  changetopom(1:n,m) = changetopo(:);
    atbndrym(1:n,m) = atbndry(:);
    % zerolengthm(1:n,m) = zerolength(:);
end %for m=1:M
